/***************************************************************************
 *   ometer is software for processing biochemical profiling data          *
 *                                                                         *
 *   Copyright (C) 2004 by Pedro Mendes, Virginia Bioinformatics Institute *
 *   mendes@vt.edu                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 ***************************************************************************/

/***************************************************************************
 * pca.cpp header for principal component analysis                         *
 ***************************************************************************/ 

int pca( map <string, datum *> &entity, vector< vector<string> > &sampleName, int hasclass, vector< vector<string> > &classLabel, long int totstates, double threshold, int newdim, bool doplots, bool png, int biplotdim, double biplotalpha, const char *bpvars, const char *ofname, FILE *htmlfile, int verbose );
int calculateAverages( map <string, datum *> &entity, int state, double *avg, int dim );
int createVariance(  map <string, datum *> &entity, int state, double *var, double *avg, int dim );
int loadDataMatrix( map <string, datum *> &entity, int state, double *datam, c_int dimi, c_int dimj );
