/***************************************************************************
 *   ometer is software for processing biochemical profiling data          *
 *                                                                         *
 *   Copyright (C) 2004 by Pedro Mendes, Virginia Bioinformatics Institute *
 *   mendes@vt.edu                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 ***************************************************************************/

/***************************************************************************
 * discriminant.cpp header for discriminant analysis                       *
 ***************************************************************************/ 

int ga_dfa2( map <string, datum *> &entity,
			int etot,
			vector <int> &sampleno,
			int popul,
			int ngenes,
			int generations,
			float mutrate,
			vector< vector<string> > &classLabel,
			vector< vector<string> > &sampleName,
			c_int totstates,
			bool doplots, 
			bool png,
			const char *ofname, 
			FILE *htmlfile,
			int verbose 
		);
